/**
 *   G O M M A - Generic Ontology Mapping Management and Analysis
 * 
 * This code may be freely distributed and modified under the
 * terms of the GNU Lesser General Public License. This should
 * be distributed with the code. If you do not have a copy,
 * see:
 *
 *      http://www.gnu.org/copyleft/lesser.html
 *
 * Copyright for this code is held jointly by the individual
 * authors. These should be listed in @author doc comments.
 *
 * For more information on the GOMMA project and its aims,
 * or to join the project, visit the web pages
 * at:
 *
 *      http://www.izbi.de/
 *
 * and
 *
 *      http://dbs.uni-leipzig.de
 *
 * Interdisciplinary Centre for Bioinformatics, University of Leipzig
 *
 * creation date: 2008/09/04
 * 
 * changes: --
 * 
 **/
package org.gomma.util.graph.algorithm;

import org.gomma.exceptions.GraphInitializationException;
import org.gomma.util.graph.DirectedAcyclicGraphImpl;
import org.gomma.util.graph.DirectedGraph;
import org.gomma.util.graph.DirectedGraphImpl;
import org.gomma.util.graph.Edge;
import org.gomma.util.graph.Graph;
import org.gomma.util.graph.GraphImpl;
import org.gomma.util.graph.Node;
import org.gomma.util.graph.NodeSet;
import org.gomma.util.graph.TreeImpl;

/**
 * The class computes the induced sub-graph of a given graph G=(V,E)
 * and and the specified node set V' as subset of V. The class has
 * separate methods for handling undirected and directed graphs.
 * @author Toralf Kirsten (tkirsten@izbi.uni-leipzig.de)
 * @version 1.0
 * @since JDK1.5
 */
public class InducedSubGraph {

	/**
	 * The method returns the induced undirected sub-graph G'=(V',E') of the given 
	 * undirected graph G=(V,E), such that V' is a subset of V and E' is a subset 
	 * of E. The induced sub-graph will be generated by using the given node set V'.
	 * @param g undirected graph G which is used to generate a induced sub-graph of it
	 * @param nodeSet node set V' which is a subset of V (G=(V,E)
	 * @return undirected graph G' as induced sub-graph of G
	 * @throws GraphInitializationException
	 */
	public static <N extends Node,E extends Edge> Graph<N,E> getInducedSubGraph(Graph<N,E> g, NodeSet<N> nodeSet) throws GraphInitializationException {
		Graph<N,E> graph = new GraphImpl<N,E>();
		
		for (N n : nodeSet.getElementSet()) graph.addNode(n);
		for (E e : g.getEdgeCollection()) {
			if (nodeSet.contains(g.getNode(e.getFromID())) && nodeSet.contains(g.getNode(e.getToID())))
				graph.addEdge(e);
		}
		
		return graph;
	}
	
	/**
	 * The method returns the induced directed sub-graph G'=(V',E') of the given 
	 * directed graph G=(V,E), such that V' is a subset of V and E' is a subset 
	 * of E. The induced sub-graph will be generated by using the given node set V'.
	 * @param g directed graph G which is used to generate a induced sub-graph of it
	 * @param nodeSet node set V' which is a subset of V (G=(V,E)
	 * @return directed graph G' as induced sub-graph of G
	 * @throws GraphInitializationException
	 */
	public static <N extends Node,E extends Edge> DirectedGraph<N,E> getInducedSubGraph(DirectedGraph<N,E> g, NodeSet<N> nodeSet) throws GraphInitializationException {
		DirectedGraph<N,E> graph;
		
		if (g instanceof TreeImpl<?,?>) graph = new TreeImpl<N,E>();
		else if (g instanceof DirectedAcyclicGraphImpl<?,?>) graph = new DirectedAcyclicGraphImpl<N,E>();
		else graph = new DirectedGraphImpl<N,E>();
		
		for (N n : nodeSet.getElementSet()) graph.addNode(n);
		for (E e : g.getEdgeCollection()) {
			if (nodeSet.contains(g.getNode(e.getFromID())) && nodeSet.contains(g.getNode(e.getToID())))
				graph.addEdge(e);
		}
		
		return graph;
	}
	
	
}
